/* $Id: ccewrap_program.h,v 1.1.1.1 2005/08/12 16:41:16 dodell Exp $ */
/* Copyright 2001 Sun Microsystems, Inc.  All rights reserved. */

#ifndef CCEWRAP_PROGRAM_H
#define CCEWRAP_PROGRAM_H

#include <glib.h>
#include "../include/xml_parse.h"

typedef struct ccewrapconf_program_t *ccewrapconf_program;

#include "ccewrap_conf.h"
#include "ccewrap_capability.h"


ccewrapconf_program mk_program (struct xml_element *);
ccewrapconf_program ccewrapconf_program_new (void);
void ccewrapconf_program_free (ccewrapconf_program);
void ccewrapconf_program_setname (ccewrapconf_program, char *);
char *ccewrapconf_program_getname (ccewrapconf_program);
void ccewrapconf_program_addcapability(ccewrapconf_program, ccewrapconf_capability);
GList *ccewrapconf_program_getcapabilities(ccewrapconf_program);
int ccewrapconf_program_allowed(ccewrapconf_program program, ccewrapconf conf, GList **validUsers);

/* flags that tell this class which vals are to be free'd by the 
 * destructor */
void ccewrapconf_program_setfree_name(ccewrapconf_program program, int);
#endif /* CCEWRAP_PROGRAM_H */
/* Copyright (c) 2003 Sun Microsystems, Inc. All  Rights Reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are met: 
 * 
 * -Redistribution of source code must retain the above copyright notice, this
 * list of conditions and the following disclaimer.
 * 
 * -Redistribution in binary form must reproduce the above copyright notice,
 * this list of conditions and the following disclaimer in the documentation
 * and/or other materials provided with the distribution. 
 *
 * Neither the name of Sun Microsystems, Inc. or the names of contributors may
 * be used to endorse or promote products derived from this software without 
 * specific prior written permission.

 * This software is provided "AS IS," without a warranty of any kind. ALL EXPRESS OR IMPLIED CONDITIONS, REPRESENTATIONS AND WARRANTIES, INCLUDING ANY IMPLIED WARRANTY OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE OR NON-INFRINGEMENT, ARE HEREBY EXCLUDED. SUN MICROSYSTEMS, INC. ("SUN") AND ITS LICENSORS SHALL NOT BE LIABLE FOR ANY DAMAGES SUFFERED BY LICENSEE AS A RESULT OF USING, MODIFYING OR DISTRIBUTING THIS SOFTWARE OR ITS DERIVATIVES. IN NO EVENT WILL SUN OR ITS LICENSORS BE LIABLE FOR ANY LOST REVENUE, PROFIT OR DATA, OR FOR DIRECT, INDIRECT, SPECIAL, CONSEQUENTIAL, INCIDENTAL OR PUNITIVE DAMAGES, HOWEVER CAUSED AND REGARDLESS OF THE THEORY OF LIABILITY, ARISING OUT OF THE USE OF OR INABILITY TO USE THIS SOFTWARE, EVEN IF SUN HAS BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
 * 
 * You acknowledge that  this software is not designed or intended for use in the design, construction, operation or maintenance of any nuclear facility.
 */
