#!/usr/bin/perl -w -I(prefix)/raqdevil/perl
# $Id: create.pl,v 1.8 2005/12/13 20:09:29 dodell Exp $
# Copyright 2005 Devon H. O'Dell, iXsystems, Inc.
# All Rights Reserved.

use CCE;

my $DEBUG = 0;
$DEBUG && open(STDERR, ">>/tmp/email.enable");
$DEBUG && warn `date`;

my $cce = new CCE( Namespace => 'Email',
                      Domain => 'base-email' );

$cce->connectfd();

my $obj = $cce->event_object();
my %settings;

open(OUT, ">(prefix)/lib/sasl2/Sendmail.conf");
print OUT "# GENERATED BY RAQdevil: DO NOT TOUCH\npwcheck_method: saslauthd\nmech_list: plain login\n";

open(OUT, ">/etc/mail/raqdevil.mc");
print OUT <<EOF;
divert(-1)

divert(0)
VERSIONID(`Auto-generated by RAQdevil create.pl')
OSTYPE(freebsd5)
DOMAIN(generic)

FEATURE(access_db, `hash -o -T<TMPF> /etc/mail/access')
FEATURE(blacklist_recipients)
FEATURE(local_lmtp)
FEATURE(mailertable, `hash -o /etc/mail/mailertable')
FEATURE(virtusertable, `hash -o /etc/mail/virtusertable')

define(`confCW_FILE', `-o /etc/mail/local-host-names')

dnl Enable for both IPv4 and IPv6 (optional)
DAEMON_OPTIONS(`Name=IPv4, Family=inet')
DAEMON_OPTIONS(`Name=IPv6, Family=inet6, Modifiers=O')

TRUST_AUTH_MECH(`GSSAPI DIGEST-MD5 CRAM-MD5 LOGIN')dnl
define(`confAUTH_MECHANISMS', `GSSAPI DIGEST-MD5 CRAM-MD5 LOGIN')dnl
define(`confDONT_BLAME_SENDMAIL', `ForwardFileInGroupWritableDirPath')dnl
define(`confBIND_OPTS', `WorkAroundBrokenAAAA')
define(`confNO_RCPT_ACTION', `add-to-undisclosed')
define(`confPRIVACY_FLAGS', `authwarnings,noexpn,novrfy')
MAILER(local)
MAILER(smtp)
EOF

open(OUT, ">/etc/mail/raqdevil.submit.mc");
print OUT <<EOF;
divert(-1)

divert(0)dnl
VERSIONID(`Auto-generated by RAQdevil create.pl')
define(`confCF_VERSION', `Submit')dnl
define(`__OSTYPE__',`')dnl dirty hack to keep proto.m4 from complaining
define(`_USE_DECNET_SYNTAX_', `1')dnl support DECnet
define(`confTIME_ZONE', `USE_TZ')dnl
define(`confDONT_INIT_GROUPS', `True')dnl
define(`confBIND_OPTS', `WorkAroundBrokenAAAA')dnl
dnl
dnl If you use IPv6 only, change [127.0.0.1] to [IPv6:::1]
DAEMON_OPTIONS(`Name=NoMTA, Addr=127.0.0.1, M=EA')dnl
FEATURE(`msp', `[127.0.0.1]')dnl
EOF

system("cd /etc/mail && make SENDMAIL_MC=raqdevil.mc SENDMAIL_SUBMIT_MC=raqdevil.submit.mc all install");

exit(0);
# Copyright (c) 2005 Devon H. O'Dell, iXsystems, Inc. All Rights Reserved.
