#!/usr/bin/perl -w -I(prefix)/raqdevil/perl
#
# $Id: clamav.pl,v 1.3 2005/12/13 20:09:31 dodell Exp $

use Sauce::Util;
use Sauce::Config;
use CCE;
use FileHandle;
use File::Path;
use I18n;
use Data::Dumper;

my $DEBUG = 0;

# connect:
my $cce = new CCE(Domain => 'base-user');
$cce->connectfd();

my $i18n = new I18n;

# retrieve info
my ($success, $new, $old) = $cce->get($cce->event_oid());

my @pwent = getpwnam($new->{name});
my $homedir = $pwent[7];
$procmailrc = $homedir . '/.procmailrc';

if (!Sauce::Util::editfile($procmailrc, *edit_procmailrc, $new))
{
	$cce->bye('FAIL', "Can't edit $procmailrc");
}

sub edit_procmailrc
{
	my ($in, $out, $new) = @_;

	my $begin = '# BEGIN ClamAv SECTION. DO NOT EDIT MARKS OR IN BETWEEN.';
	my $end = '# END ClamAv SECTION. DO NOT EDIT MARKS OR IN BETWEEN.';

	my $dropprivs = 'DROPPRIVS=yes';

	my $avconf = <<EOF;
:0fw
| (prefix)/bin/clamfilter.pl
:0:
* ^X-Virus-Status: Yes
quarantine
EOF

	print $out $dropprivs, "\n";

	while (<$in>)
	{
		if (/^$dropprivs$/) { next; }
		if (/^$begin$/)
		{
			if ($new->{clamavEnabled} == 0) {
				while(<$in>) {
					if (/^$end$/) { last; }
				}
			}
		} else {
			print $out $_;
		}
	}

	if ($new->{clamavEnabled} == 1) {
		print $out $begin, "\n";
		print $out $avconf, "\n";
		print $out $end, "\n";
	}

	return 1;
}

# all done
$cce->bye("SUCCESS");
exit(0);
