<?php
// $Id: AnonFtp.php,v 1.6 2005/10/07 06:41:44 dodell Exp $
// Copyright 2001 Sun Microsystems, Inc.  All Rights Reserved.
// AnonFtp.php.defaults.Vsite

include_once('UIExtension.php');

class AnonFtpExtension extends UIExtension
{
	function display(&$helper, &$container, &$prams)
    {
        $factory = $helper->getHtmlComponentFactory("base-ftp");
        $cce = $helper->getCceClient();

        $defaults = $cce->get($prams["CCE_SERVICES_OID"], "AnonFtp");
 
	$pageId = $prams['PAGED_BLOCK_DEFAULT_PAGE'];
       
        // construct all the form fields needed, note that only simple
        // form fields are allowd.  no composite form fields
        $ftpQuota = $factory->getInteger("AnonFtp_quota", $defaults["quota"], 1);
        
        $ftpUsers = $factory->getInteger("AnonFtp_maxConnections", 
                            $defaults["maxConnections"], 1);

        $ftpField = $factory->getMultiChoice("AnonFtp_enabled");
        $enable = $factory->getOption('anonEnable', $defaults["enabled"]);
        $enable->setLabel($factory->getLabel('anonEnable', false));

	if (isset($pageId)) {
        $enable->addFormField(
                $ftpQuota, $factory->getLabel("ftpQuota"), $pageId);
        $enable->addFormField(
                $ftpUsers, $factory->getLabel("ftpUsers"), $pageId);
        }
  
        $ftpField->addOption($enable);

        // now add the form fields to the block, assume PagedBlock
        $pageId = "AnonFtp";
        $container->addPage($pageId, $factory->getLabel("ftpTabName"));
        $container->addFormField(
                $ftpField, 
                $factory->getLabel("anonFtp"), 
                $pageId);
    }

	function handle(&$helper, &$errors, &$prams)
    {
        // have to claim all the globals needed or this function won't be able to see them
        global $AnonFtp_enabled, $AnonFtp_quota, $AnonFtp_maxConnections;
        $cce = $helper->getCceClient();
    
        // simply set the values in CCE
        $cce->set($prams["CCE_SERVICES_OID"], "AnonFtp",
            array(
                "enabled" => ($AnonFtp_enabled ? 1 : 0), 
                "quota" => $AnonFtp_quota, 
                "maxConnections" => $AnonFtp_maxConnections
            ));
    
        // add any errors that occured so they can get back to the UI
        $errors = array_merge($errors, $cce->errors());
    }
}
?>
